# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global desktopvendor	city-fan.org
%global	vjumbo		20070520

Name: xv
Version: 3.10a
Release: 18.%{__distinit}%{__distvers}
Summary: X based image viewer for darned near all images
Summary(de.UTF-8): X-basierender Bild-Viewer für praktische sämtliche Grafiken
Summary(es.UTF-8): Visualizador de imágenes para X para cuasi todos los formatos de imágenes
Summary(fr.UTF-8): Visualisateur sous X pour quasiment tous les types d'images
Summary(pl.UTF-8): Przeglądarka różnego rodzaju plików graficznych pracująca w X Window
Summary(pt_BR.UTF-8): Visualizador de imagens para X para quase todos os formatos de imagens
Summary(ru.UTF-8): Программа для просмотра и преобразования файлов изображений для X
Summary(tr.UTF-8): X tabanlı resim görüntüleyici
Summary(uk.UTF-8): Програма для перегляду та перетворення файлів зображень для X
License: Shareware
Group: Applications/Multimedia
URL: http://www.trilon.com/xv/xv.html
Source0: ftp://ftp.trilon.com/pub/xv/xv-%{version}.tar.gz
Source1: http://downloads.sf.net/png-mng/xv-3.10a-jumbo-patches-%{vjumbo}.tar.gz
Source2: DISTRIBUTE.txt
Source3: xv.desktop
Source4: xv.png
Source5: ftp://ftp.trilon.com/pub/xv/xvman310a-html.tar.gz
Source6: xv-non-english-Xman-pages.tar.bz2
Patch0: xv-jumbo-20070520-makefile.patch
Patch1: http://www.gregroelofs.com/code/xv-3.10a-enhancements.20070520-20081216.diff
Patch2: xv-3.10a-cleanup.patch
Patch3: xv-FLmask.v2.1.patch
Patch4: xv-wait.patch
Patch5: xv-3.10a-libpng15.patch
Patch6: xv-3.10a-namemax.patch
Patch7: xv-3.10a-xvcut.patch
Patch10: xv-jumbo-20070520-no-jasper.patch
Patch11: xv-3.10a-utf8.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires: desktop-file-utils, libjpeg-devel, libpng10-devel, libtiff-devel

# Red Hat Linux: XFree86
%if "%{__distinit}" == "rhl"
BuildRequires:		XFree86-devel
%global have_hicolor	0
%global have_posttrans	0
%global noarchsubpkgs	0
%global nojp2k		1
%global xlibdir		/usr/X11R6/%{_lib}
# man required for ownership of %%{_mandir}/{fi,pl}
Requires: man
Requires(post):		desktop-file-utils
Requires(postun):	desktop-file-utils
%endif

# Red Hat Enterprise Linux:
%if "%{__distinit}" == "rhel"
# Red Hat Enterprise Linux 3: XFree86
%if "%(expr %{__distvers} '<' 4)" == "1"
BuildRequires:		XFree86, XFree86-devel
%global have_hicolor	0
%global have_posttrans	0
%global nojp2k		1
%global xlibdir		/usr/X11R6/%{_lib}
# man required for ownership of %%{_mandir}/{fi,pl}
Requires: man
Requires(post):		desktop-file-utils
Requires(postun):	desktop-file-utils
%endif
# Red Hat Enterprise Linux 4: X.org (monolithic)
%if "%(expr %{__distvers} '=' 4)" == "1"
BuildRequires:		xorg-x11-devel
%global have_hicolor	1
%global have_posttrans	0
%global nojp2k		0
%global xlibdir		/usr/X11R6/%{_lib}
# man required for ownership of %%{_mandir}/{fi,pl}
Requires: man
Requires(post):		desktop-file-utils
Requires(postun):	desktop-file-utils
%endif
# Red Hat Enterprise Linux > 4: Modular X
%if "%(expr %{__distvers} '>' 4)" == "1"
BuildRequires:		libX11-devel, libXt-devel
%global have_hicolor	1
%global have_posttrans	1
%global nojp2k		0
%global xlibdir		%{_libdir}
%endif
# RHEL 6 onwards has noarch subpackage support
%if "%(expr %{__distvers} '>' 5)" == "1"
%global noarchsubpkgs	1
%else
%global noarchsubpkgs	0
%endif
%endif

# Fedora Core
%if  "%{__distinit}" == "fc"
# FC 1..2: Monolithic XFree86
%if "%{__distvers}" == "1" || "%{__distvers}" == "2"
BuildRequires:		XFree86-devel
%global xlibdir		/usr/X11R6/%{_lib}
# man required for ownership of %%{_mandir}/{fi,pl}
Requires: man
Requires(post):		desktop-file-utils
Requires(postun):	desktop-file-utils
%endif
# FC 3..4: Monolithic X.org
%if "%{__distvers}" == "3" || "%{__distvers}" == "4"
BuildRequires:		xorg-x11-devel
%global xlibdir		/usr/X11R6/%{_lib}
# man required for ownership of %%{_mandir}/{fi,pl}
Requires: man
Requires(post):		desktop-file-utils
Requires(postun):	desktop-file-utils
%endif
# FC5 onwards: Modular X
%if "%(expr %{__distvers} '>' 4)" == "1"
BuildRequires:		libX11-devel, libXt-devel
%global xlibdir		%{_libdir}
# FC5 has devel packages that stupidly don't require pkgconfig
%if "%{__distvers}" == "5"
BuildRequires:		pkgconfig
%endif
%endif
# FC2 onwards has hicolor-icon-theme, needed for ownership of %%{_datadir}/icons/hicolor/48x48/apps/
%global have_hicolor	%(expr %{__distvers} '>' 1)
# FC4 onwards have rpm >= 4.4.0 and hence %%posttrans support
%global have_posttrans	%(expr %{__distvers} '>' 3)
# FC7 onwards have JasPer
%global nojp2k		%(expr %{__distvers} '<' 7)
# FC10 onwards have noarch subpackage support
%global noarchsubpkgs	%(expr %{__distvers} '>' 9)
%endif

# Use JasPer for JPEG2000 support if available
%if ! %{nojp2k}
BuildRequires:		jasper-devel
%endif

# Require hicolor-icon-theme ownership of %%{_datadir}/icons/hicolor/48x48/apps/ if available
%if %{have_hicolor}
Requires:		hicolor-icon-theme
%endif

%description
This is the famous 'xv' by John Bradley. It is shareware, but we ship
it with the permission of the authors. It is a graphics viewer for
many file types, including gif, jpg, tiff, xwd, etc. It also has
manipulation features such as cropping, expanding, etc. Patched to
include flmask, a popular feature in Japan.

%description -l de.UTF-8
Dies ist das berühmte 'xv' von John Bradley, ein Shareware- Programm,
das wir mit Erlaubnis des Autors liefern. Es ist ein Grafik-Viewer für
diverse Dateitypen, einschließlich gif, funktionen wie Trimmen,
Strecken u.ä. Mit flmask.

%description -l es.UTF-8
Este es el famoso 'xv' de John Bradley. Es shareware, pero nosotros lo
distribuimos con la permisión de los autores. Es un visor gráfico para
varios tipos de archivos, incluyendo gif, jpg, tiff, xwd, etc. También
posee características de manejo como corte, expansión, etc.

%description -l fr.UTF-8
Le célébre xv de John Bradley. C'est shareware, mais nous le
distribuons avec la permission de l'auteur. C'est un visualiseur
graphique pour de nombreux formats de fichier dont gif, jpg, tiff,
xwd, etc. Il offre aussi des fonctionnalités comme la capture,
l'extension, la retouche de palette, etc. Flmask.

%description -l pl.UTF-8
Słynne 'xv' Johna Bradleya. Jest to program shareware, ale
udostępniamy go za zgodą autora. Jest to przeglądarka plików
graficznych w różnych formatach, takich jak: gif, jpg, tiff, xwd i
innych. Ma też proste możliwości obróbki obrazków, takie jak obcinanie
czy rozszerzanie. Zawiera obsługę flmask.

%description -l pt_BR.UTF-8
Este é o famoso 'xv' de John Bradley. Ele é shareware, mas nós o
distribuimos com a permissão dos autores. É um visualizador gráfico
para vários tipos de arquivos, incluindo gif, jpg, tiff, xwd, etc.
Também possui características de manipulação como corte, expansão,
etc.

%description -l ru.UTF-8
Xv - это программа для просмотра и преобразования изображений для X
Window System. Xv умеет показывать GIF, JPEG, TIFF, PBM, PPM, PDF, X11
bitmap, Utah Raster Toolkit RLE, PDS/VICAR, Sun Rasterfile, BMP, PCX,
IRIS RGB, XPM, Targa, XWD, PostScript(TM) и PM. Xv также умеет делать
простую обработку изображений - cropping, expanding, снимки экрана и
т.п.

%description -l tr.UTF-8
xv başta PNG, GIF, JPG, BMP, XBM, XPM olmak üzere birçok resim
dosyasını görüntüleyebilir, değişik formatlarda kaydedebilir ve
üzerinde boyutlandırma, renk değiştirme gibi bazı temel işlemleri
yapabilir. Çok detaylı işlemler yapamamasına rağmen temel resim
işlemlerinde öncellikle kullanılabilecek, kullanışlı arayüzüne sahip
bir programdır. Flmask.

%description -l uk.UTF-8
Xv - це програма для перегляду та перетворення зображень для X Window
System. Xv вміє показувати GIF, JPEG, TIFF, PBM, PPM, PDF, X11 bitmap,
Utah Raster Toolkit RLE, PDS/VICAR, Sun Rasterfile, BMP, PCX, IRIS
RGB, XPM, Targa, XWD, PostScript(TM) та PM. Xv також вміє робити
просту обробку зображень - cropping, expanding, знімки экрану і т.і.

%package doc
Summary: Manuals in various formats for the xv image viewer
Group: Documentation
%if %{noarchsubpkgs}
BuildArch: noarch
%endif

%description doc
Manuals in various formats for the xv image viewer, plus technical details
of the various image file formats supported.

%prep
%setup -q -b 1 -a 5 -a 6

# Apply 20070520 jumbo enhancement patch, bundled with %%{SOURCE1}
patch -p1 < ../xv-3.10a-jumbo-fix-enh-patch-%{vjumbo}.txt
rm ../xv-3.10a-jumbo-fix-enh-patch-%{vjumbo}.txt

# Fix compiler options, install directories; enable JPEG 2000 support
%patch0 -p1

# Interim jumbo patch update
%patch1 -p1

# Clean up code
%patch2 -p1

# Add FLmask feature (rebased patch; original version won't apply after jumbo patch)
%patch3 -p1

# Replace CLK_TCK with sysconf(_SC_CLK_TCK) (http://bugzilla.rpmfusion.org/1929)
%patch4 -p1

# libpng 1.5 compatibility
%patch5 -p0

# NAME_MAX buffer overflow fix
%patch6 -p1

# cut/paste fix for 24bit+ images
%patch7 -p1

# JasPer (JPEG 2000 support) only appeared in Fedora 7,
# but is available in EPEL for EL-4 and EL-5
%if %{nojp2k}
%patch10 -p1
%endif

# Include permission to distribute
install -m 0644 -p %{SOURCE2} .

# Recode docs as UTF-8
%patch11 -p1 -R -b .utf8

# Reorganize docs
#
# Note: Man pages for p?m file formats would conflict with netpbm-progs if installed under %%{_mandir}
mv 00_README README.FLmask
mv docs/README README.docs
mkdir docs/{formats,manuals}/
mv docs/{bmp.doc,epsf.ps,gif*,p[bgp]m.5,xpm.ps} docs/formats/
mv docs/{xvdocs.{ps,pdf},xvtitle.ps} docs/manuals/

# HTML manual
mv -f xvman310a docs/manuals/html

# Fix line endings
for doc in docs/manuals/xv*.ps; do
  sed -e 's/\r$//' ${doc} > ${doc}.unix
  touch -r ${doc} ${doc}.unix
  mv -f ${doc}.unix ${doc}
done

# Fix directory location of X libs
sed -i -e 's@-L/usr/X11R6/lib[[:space:]]@-L%{xlibdir} @' Makefile

%build
# Use libpng10 rather than latest libpng
#
# This is not because later versions won't work, it's because I'm using xv as a
# test vehicle for libpng10 updates
make %{?_smp_mflags} \
	CCOPTS="%{optflags} `pkg-config --cflags libpng10 2>/dev/null`" \
	PNGLIB=-lpng10

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

desktop-file-install \
  --vendor %{desktopvendor} \
  --dir %{buildroot}%{_datadir}/applications \
  %{SOURCE3}

install -D -p -m 0644 %{SOURCE4} \
  %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/xv.png

# Non-English man pages
install -D -p -m 0644 fi/man1/xv.1 \
  %{buildroot}%{_mandir}/fi/man1/xv.1
install -D -p -m 0644 pl/man1/xvpictoppm.1 \
  %{buildroot}%{_mandir}/pl/man1/xvpictoppm.1

# Populate the docs directory
mkdir -p %{buildroot}%{_docdir}/xv-%{version}/
for doc in \
  BUGS \
  CHANGELOG \
  copyright.h \
  CPMASK \
  DISTRIBUTE.txt \
  IDEAS \
  README \
  README.docs \
  README.FLmask \
  README.jumbo \
  README.pcd \
  xv_mgcsfx.sample \
  docs/bigxv.jpg \
  docs/formats/ \
  docs/manuals/
do
  cp -a ${doc} %{buildroot}%{_docdir}/xv-%{version}/
done

%clean
rm -rf %{buildroot}

%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &> /dev/null || :

%postun
if [ $1 -eq 0 ] ; then
  touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
  gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi
update-desktop-database &> /dev/null || :

%if %{have_posttrans}
%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
# Note that icon cache updates are only needed on FC4 and later, and
# %%posttrans is always available on FC4 and later
%endif

%files
%defattr(-,root,root,-)
%doc %{_docdir}/xv-%{version}/BUGS
%doc %{_docdir}/xv-%{version}/CHANGELOG
%doc %{_docdir}/xv-%{version}/copyright.h
%doc %{_docdir}/xv-%{version}/CPMASK
%doc %{_docdir}/xv-%{version}/DISTRIBUTE.txt
%doc %{_docdir}/xv-%{version}/IDEAS
%doc %{_docdir}/xv-%{version}/README
%doc %{_docdir}/xv-%{version}/README.FLmask
%doc %{_docdir}/xv-%{version}/README.jumbo
%doc %{_docdir}/xv-%{version}/README.pcd
%doc %{_docdir}/xv-%{version}/xv_mgcsfx.sample
%{_bindir}/bggen
%{_bindir}/vdcomp
%{_bindir}/xcmap
%{_bindir}/xv
%{_bindir}/xvpictoppm
%{_datadir}/applications/%{desktopvendor}-xv.desktop
# If we don't have hicolor-icon-theme as a dependency, we need to own %%{_datadir}/icons/ and below
%if %{have_hicolor}
%{_datadir}/icons/hicolor/48x48/apps/xv.png
%else
%{_datadir}/icons/
%endif
%{_mandir}/man1/bggen.1*
%{_mandir}/man1/vdcomp.1*
%{_mandir}/man1/xcmap.1*
%{_mandir}/man1/xv.1*
%{_mandir}/man1/xvpictoppm.1*
%lang(fi) %{_mandir}/fi/man1/xv.1*
%lang(pl) %{_mandir}/pl/man1/xvpictoppm.1*

%files doc
%defattr(-,root,root,-)
%doc %{_docdir}/xv-%{version}/README.docs
%doc %{_docdir}/xv-%{version}/bigxv.jpg
%doc %{_docdir}/xv-%{version}/formats/
%doc %{_docdir}/xv-%{version}/manuals/

%changelog
* Fri Mar 29 2013 Paul Howarth <paul@city-fan.org> 3.10a-18
- Patch for cut/paste bug in 24+ bit mode (by Mark Brader <msb@vex.net>)
- Further buffer overflow fix for overly long command line argument

* Thu Mar 14 2013 Paul Howarth <paul@city-fan.org> 3.10a-17
- Additional fix for long filename buffer overflow

* Tue Mar  5 2013 Paul Howarth <paul@city-fan.org> 3.10a-16
- Fix buffer overflow caused by filenames longer than the window title limit

* Mon Aug  6 2012 Paul Howarth <paul@city-fan.org> 3.10a-15
- Rebuild for libtiff.so.5 (libtiff 4.0) in Rawhide

* Fri Dec  9 2011 Paul Howarth <paul@city-fan.org> 3.10a-13
- Add patch from Gentoo for libpng 1.5 compatibility

* Thu Sep  8 2011 Paul Howarth <paul@city-fan.org> 3.10a-12
- Fix wait timer for slideshows (http://bugzilla.rpmfusion.org/1929)

* Mon Aug  1 2011 Paul Howarth <paul@city-fan.org> 3.10a-9
- Use patch instead of scripted iconv to convert character encodings
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun Jul 18 2010 Paul Howarth <paul@city-fan.org> 3.10a-8
- Drop dependency on man from RHEL-5 onwards, where %%{_mandir}/{fi,pl} are
  included in the filesystem package

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> 3.10a-7
- Fix dist tag for RHEL-6 Beta

* Mon Feb 22 2010 Paul Howarth <paul@city-fan.org> 3.10a-6
- Dist tag for Rawhide no longer needs special-casing

* Wed Sep 16 2009 Paul Howarth <paul@city-fan.org> 3.10a-5
- Update desktop file MimeType list (thanks to goeran@uddeborg.se)

* Sat Sep  5 2009 Paul Howarth <paul@city-fan.org> 3.10a-4
- Resync with RPM Fusion package (cosmetic changes mainly)
- Add image format docs in doc subpackage

* Thu Aug 20 2009 Paul Howarth <paul@city-fan.org> 3.10a-3
- Include Greg Roelofs' jumbo patch (20070520)
- Include Greg Roelofs' jumbo patch update (20081216)
- Drop patches included in/superseded by the jumbo patch:
  - xv-3.10a-lvalue.patch
  - xv-3.10a-png-1.2d.tar.gz
  - xv-croppad.patch
  - xv-deepcolor.patch
  - xv-exceed_grab_patch.txt
  - xv-gifpatch
  - xv-grabpatch
  - xv-JPEG.patch
  - xv-longname.patch
  - xv-mp-tiff-patch
  - xv-pdf.patch
  - xv-png-fix2.patch
  - xv-TIFF.patch
  - xv-vispatch
- Include RPM Fusion Makefile patch (adds JPEG2000 support)
- Drop xv-PLD.patch, superseded by combination of jumbo and RPM Fusion patches
- Only explicitly buildrequire pkgconfig for FC5 build
- Define RPM macros in global scope
- Switch upstream URL to ftp.trilon.com
- Add DISTRIBUTE.txt - permission to distribute from John Bradley
- Add doc subpackage for XV manual in PS, PDF, and HTML formats
- Disable JPEG2000 (jasper) support for releases prior to Fedora 7
- Install icon in %%{_datadir}/icons/hicolor/48x48/apps/ rather than
  %%{_datadir}/pixmaps/
- Add scriptlets for updating the icon cache and MIME databases
  (desktop-file-utils scriptlet dependencies only needed prior to FC5)
- Include non-English man pages from PLD in package
- Add translations for spec and desktop file from PLD
- Make docs package noarch where possible (RHEL6, FC10 onwards)

* Wed Oct 29 2008 Paul Howarth <paul@city-fan.org> 3.10a-2
- Fixed up patches to apply without fuzz

* Wed May 30 2007 Paul Howarth <paul@city-fan.org> 3.10a-1
- Import from PLD release 3.10a-21; reluctantly removed the translations in
  the spec file because I couldn't figure out what encoding(s) they were in
  (certainly not UTF-8)
